package org.rcisoft.business.buildtp.controller;


/*固定导入*/

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.util.UserUtil;
import org.rcisoft.business.buildtp.entity.BuildTp;
import org.rcisoft.business.buildtp.service.BuildTpService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
*
 * @author
 * @date 2018-4-3 10:11:34
 */
@RestController
@RequestMapping("buildtp")
public class BuildTpController extends PaginationController<BuildTp> {

    @Autowired
    private BuildTpService buildTpServiceImpl;


    @ApiOperation(value="添加建筑类型", notes="添加建筑类型")
    @PostMapping(value = "/add")
    public Result add(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.save(buildTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        buildTp);
    }

    @ApiOperation(value="修改建筑类型", notes="修改建筑类型")
    @PutMapping("/update")
    public Result update(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.merge(buildTp);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                buildTp);
    }

    @ApiOperation(value="删除建筑类型", notes="删除建筑类型")
    @DeleteMapping("/delete")
    public Result delete(@Valid BuildTp buildTp) {
        PersistModel data = buildTpServiceImpl.delete(buildTp);
        return Result.builder(data);
    }

    @ApiOperation(value="建筑类型列表", notes="建筑类型列表")
    @GetMapping(value = "/queryBuildTpList")
    public List<BuildTp> queryBuildTpList() {
        return buildTpServiceImpl.queryBuildTpList();
    }
}
