package org.rcisoft.business.device.assets.dao;

import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.device.assets.vo.DeviceAssetStatisticVo;
import org.rcisoft.core.base.BaseMapper;
import org.rcisoft.business.device.assets.entity.BusDevice;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;


import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-4-12 15:33:23.
*/
@Repository
public interface BusDeviceRepository extends BaseMapper<BusDevice> {

    /**
    * 分页查询 busDevice
    *
    */
    @Select("<script>select a.*,b.FAC_NM,DATE_FORMAT(a.install_date,'%Y-%m-%d %H:%i:%s') INSTALL_DAY from bus_device a left join bus_factory b on a.fac_id = b.fac_id where 1=1 and a.pro_id = #{proId} " +
            "<if test='devTpId != null'> and a.dev_tp_id = #{devTpId}</if>"
            + "</script>")
    List<Map<String,Object>> queryBusDevices(BusDevice busDevice);

    /*
    通过项目id与子系统id获取子系统中的所有设备
    @param sysId  子系统id
    @param proId  项目id
     */
    List<DeviceAssetStatisticVo> getBusDevicesBySysId(@Param("sysId") String sysId, @Param("proId") String proId);

    /**
     * 通过项目id获取项目名称
     * @param proId
     * @return
     */
    String getProNameByProId(@Param("proId") String proId);

    /**
     * 通过系统id获取系统名称
      * @param sysId
     * @return
     */
    String getSysNameBySysId(@Param("sysId") String sysId);

    /**
     * 查询设备是否有原始数据
     * @param map
     * @return
     */
    @Select("<script>select a.tm from total_original a,bus_device b where a.dev_num = b.dev_num and  b.dev_id = #{dev_id} limit 1</script>")
    List<Map<String,Object>> queryOriginalByDev(Map<String,Object> map);

    /**
     * 根据设备编号查询设备信息
     * @param devNum
     * @return
     */
    @Select("<script>select * from bus_device where dev_num = #{devNum}</script>")
    List<Map<String,Object>> queryDeviceByDevNum(@Param("devNum") String devNum);
}

