package org.rcisoft.business.device.inspection.controller;


/*固定导入*/

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.device.inspection.service.InspectionService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
* Created by  on 2018-4-18 15:41:54.
*/
@RestController
@RequestMapping("InspectionEvaluate")
public class InspectionController {
    @Autowired
    private InspectionService inspectionService;

    @ApiOperation(value = "通过项目查询最新的项目巡检记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "proId", value = "项目id", required = true,paramType = "path", dataType = "varvhar")
    })
    @ResponseBody
    @GetMapping(value = "/listTheLastInspection/{proId}")
    public Result listTheLastInspection(@PathVariable("proId") String proId){
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                inspectionService.listTheLastInspectionInfomatinByProIdAndFlag(proId));
    }


    @ApiOperation(value = "查询该项目下某个设备的所有巡检记录")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "proId", value = "项目id", required = true,paramType = "path", dataType = "varvhar"),
            @ApiImplicitParam(name = "devNum", value = "设备编号", required = true,paramType = "path", dataType = "varvhar")
    })
    @ResponseBody
    @GetMapping(value = "/listAllInspection/{proId}/{devNum}")
    public Result listAllInspection(@PathVariable("proId") String proId, @PathVariable("devNum") String devNum){
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                inspectionService.listAllInspectionInfomatinByProIdAndDevNum(proId, devNum));
    }

}
