package org.rcisoft.business.device.inspection.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.device.inspection.dao.InspectionRepository;
import org.rcisoft.business.device.inspection.service.InspectionService;
import org.rcisoft.common.constants.DeviceInspectFlagConstant;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-4-18 15:41:54.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class InspectionServiceImpl implements InspectionService {

    @Autowired
    private InspectionRepository inspectionRepository;

    @Override
    public List<Map<String, Object>> listTheLastInspectionInfomatinByProIdAndFlag(String proId) {
        String flag = DeviceInspectFlagConstant.THE_LAST_FLAG;
        return inspectionRepository.listTheLastInspectionInfomatinByProIdAndFlag(proId,flag);
    }

    @Override
    public List<Map<String, Object>> listAllInspectionInfomatinByProIdAndDevNum(String proId, String devNum) {
        return inspectionRepository.listAllInspectionInfomatinByProIdAndDevNum(proId, devNum);
    }
}
