package org.rcisoft.business.evaluate.project.controller;


/*固定导入*/

import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.evaluate.project.service.ProjectEvaluateService;
import org.rcisoft.business.evaluate.project.vo.ProjectEvaluateDTO;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
* Created by  on 2018-4-18 15:41:54.
*/
@RestController
@RequestMapping("ProjectEvaluate")
public class ProjectEvaluateController {

    @Autowired
    private ProjectEvaluateService projectEvaluateService;


    @ApiOperation(value="项目评估", notes="返回项目相关信息")
    @GetMapping("/listProjectInformation")
    public Result listProjectInformation(ProjectEvaluateDTO projectEvaluateDTO) {
        String year = projectEvaluateDTO.getYear();
        Integer pageNum = projectEvaluateDTO.getPageNum();
        Integer pageSize = projectEvaluateDTO.getPageSize();
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, projectEvaluateService.listProjectInformationByYear(year,pageNum,pageSize));
    }
}
