package org.rcisoft.business.evaluate.project.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.evaluate.project.dao.ProjectEvaluateRepository;
import org.rcisoft.business.evaluate.project.service.ProjectEvaluateService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-4-18 15:41:54.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class ProjectEvaluateServiceImpl implements ProjectEvaluateService {

    @Autowired
    private ProjectEvaluateRepository projectEvaluateRepository;


    /** 根据年份，分别查出每个项目的项目评估信息，需要页容量以及当前页数
     * @param year
     * @param pageNum
     * @param pageSize
     * @return
     */
    @Override
    public List<Map<String, Object>> listProjectInformationByYear(String year, Integer pageNum, Integer pageSize) {
        Integer start = pageSize * (pageNum - 1);
        Integer end = pageSize * pageNum;
        List<Map<String, Object>> maps = projectEvaluateRepository.listProjectInformationByYear(year, start, end);
        return maps;
    }
}
