package org.rcisoft.business.evaluate.team.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.evaluate.team.service.TeamAssessmentService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;




/**
 * Created by liuzhichao on 2018-4-18 17:25:07.
 */
@RestController
@RequestMapping("TeamAssessment")
public class TeamAssessmentController {

    @Autowired
    private TeamAssessmentService teamAssessmentService;

    @ApiOperation(value="团队评估列表信息", notes="团队评估列表信息")


    @ApiImplicitParams({@ApiImplicitParam(name = "type", value = "团队类型", required = true, dataType = "字符串")})
    @GetMapping("/getTeamAssessmentInfo")
    public Result TeamAssessmentInfo(String type) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, teamAssessmentService.getTeamAssessmentInfo(type));
    }

    @ApiOperation(value="团队评估右侧信息", notes="团队评估右侧信息")
    @ApiImplicitParams({@ApiImplicitParam(name = "priId", value = "负责人主键", required = true, dataType = "字符串")})
    @GetMapping("/getTeamAssessmentRightInfo")
    public Result TeamAssessmentRightInfo(@RequestParam String priId) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, teamAssessmentService.getTeamAssessmentRightInfo(priId));
    }




}
