package org.rcisoft.business.evaluate.team.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.evaluate.team.entity.BusTeam;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * Created by liuzhichao on 2018/4/19.
 */
@Repository
public interface BusTeamRepository extends BaseMapper<BusTeam>{



    @Select("<script>select a.*,count(1) teamNumber,sum(b.BLD_AREA) area from bus_team a,bus_project b where " +
            " case when a.TEAM_TYPE = '1' then a.TEAM_ID=b.TEAM_ID_ON else a.TEAM_ID=b.TEAM_ID_OFF end" +
            "<if test=\"type != null\"> and TEAM_TYPE = #{type}</if>" +
            " GROUP BY a.TEAM_ID</script>")
    @ResultMap(value = "BaseResultMap" )
    List<BusTeam> selectByTeamId(@Param("type") String type);

    /**
     * 所有业主列表
     * @return
     */
    @Select("<script>select * from bus_team</script>")
    List<Map<String,Object>> listTeamAll();

    /**
     * 分页查询 busTeam
     *
     */
    @Select("<script>select a.*,b.* from bus_team a,sys_principal b  where a.pri_id =b.pri_id " +
            " and team_type = #{teamType}"
            + "</script>")
    List<Map<String,Object>> queryBusTeams(@Param("teamType") String teamType);



}
