package org.rcisoft.business.mainte.adaptive.dao;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.ResultType;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.mainte.adaptive.entity.BusTemperature;
import org.rcisoft.business.mainte.adaptive.vo.Params;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by JiChao on 2018/4/28.
 */
@Repository
public interface BusTemperatureRepository {

    /**
     * 根据时间、code查询实际温度
     * @param params
     * @return
     */
    @Select("<script>select t.TM,t.TEMPERATURE from bus_temperature t " +
            "where t.CODE=#{code} and date_format(t.TM, '%Y-%c-%e')=#{time}</script>")
    @ResultMap(value = "BaseResultMap")
    List<BusTemperature> queryBusTemperatureList(Params params);

    /**
     * 批量添加每天24小时的温度
     * @param list
     * @return
     */
    @Insert("<script><foreach collection=\"list\" item=\"item\" open=\"\" close=\"\" separator=\";\">" +
            "insert into bus_temperature(TM,TEMPERATURE,CODE) values(#{item.tm},#{item.temperature},#{item.code})" +
            "</foreach></script>")
    @ResultType(Integer.class)
    Integer batchSaveBusTemperature(List<BusTemperature> list);

}
