package org.rcisoft.business.mainte.energyplan.service;


import org.rcisoft.business.mainte.energyplan.entity.BusEnergyPlan;
import org.rcisoft.business.mainte.energyplan.vo.EnergyPlanVo;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.aop.PageUtil;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-4-17 17:47:37.
 */
public interface BusEnergyPlanService {

    /**
    * 保存 
    * @param
    * @return
    */
    PersistModel save(EnergyPlanVo energyPlan)throws Exception;

    /**
    * 删除能耗计划
    * @return
    */
     PersistModel remove(String devNum,String day);


    /**
     * 根据项目查询某一天的电、气的总能耗
     * @param proid
     * @param day
     * @return
     */
    List<Map<String,Object>> queryEnergyPlanDay(String proid, String day);

    /**
     * 查询能耗计划
     * @param
     * @return
     */
    List<Map<String,Object>> queryEnergyPlanList(String proid, String day)throws Exception;

    /**
     * 获取设备类型
     * @return
     */
    List<Map<String,Object>> queryDeviceTp();

    /**
     * 根据设备类型获取设备
     * @param
     * @return
     */
    List<Map<String,Object>> queryDeviceByTp(String dev_tp_id);

    List<Map<String, Object>> queryBusEnergyRealCount(String proid, String day);

    /**
     * 计划执行
     * @param proid 项目主键
     * @param day 日期
     * @return
     * @throws Exception
     */
    List<Map<String,Object>> queryEnergyPlanExecute(String proid,String day)throws Exception;

    List<Map<String,Object>> queryEnergyPowerCompare(String dev_num,String day);

    int paramLibraryOperate(Map<String,Object> map);



}
