package org.rcisoft.business.mainte.fault.controller;

import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.mainte.fault.entity.BusDeviceFault;
import org.rcisoft.business.mainte.fault.service.BusDeviceFaultService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.controller.PaginationController;

/**
* Created by  on 2018-4-17 11:19:46.
*/
@RestController
@RequestMapping("busdevicefault")
public class BusDeviceFaultController extends PaginationController<BusDeviceFault> {

    @Autowired
    private BusDeviceFaultService busDeviceFaultServiceImpl;

    @ApiOperation(value="故障次数", notes="返回日期、次数的json数组")
    @ApiImplicitParams({@ApiImplicitParam(name = "proId", value = "项目类型主键", required = true, dataType = "字符串"),
            @ApiImplicitParam(name = "year", value = "年份，如：2018", required = true, dataType = "字符串或数字"),
            @ApiImplicitParam(name = "month", value = "月份，如：6", required = true, dataType = "字符串或数字")
    })
    @RequestMapping("/statFault")
    public Result statFault(@RequestParam String proId, @RequestParam String year, @RequestParam String month) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, busDeviceFaultServiceImpl.statFault(proId, year, month));
    }

    @ApiOperation(value="故障统计列表", notes="返回 时间、系统名称、设备名称、参数名称、故障内容")
    @ApiImplicitParams({@ApiImplicitParam(name = "proId", value = "项目类型主键", required = true, dataType = "字符串"),
            @ApiImplicitParam(name = "year", value = "年份，如：2018", required = true, dataType = "字符串或数字"),
            @ApiImplicitParam(name = "month", value = "月份，如：6", required = true, dataType = "字符串或数字")
    })
    @RequestMapping("/queryFaultList")
    public Result queryFaultList(@RequestParam String proId, @RequestParam String year, @RequestParam String month) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, busDeviceFaultServiceImpl.queryFaultList(proId, year, month));
    }

}
