package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusDeviceMeter;
import org.rcisoft.business.manage.service.BusDeviceMeterService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
* Created by  on 2018-5-2 16:09:29.
*/
@RestController
@RequestMapping("busdevicemeter")
public class BusDeviceMeterController extends PaginationController<BusDeviceMeter> {

    @Autowired
    private BusDeviceMeterService busDeviceMeterServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/add")
    public Result add(@Valid BusDeviceMeter busDeviceMeter) {
        PersistModel data = busDeviceMeterServiceImpl.save(busDeviceMeter);
        return Result.builder(data);
    }


    @ApiOperation(value="修改表具", notes="修改表具")
    @PutMapping("/update")
    public Result update(@Valid BusDeviceMeter busDeviceMeter) {
        PersistModel data = busDeviceMeterServiceImpl.merge(busDeviceMeter);
        return Result.builder(data);
    }

    @ApiOperation(value="删除表具", notes="删除表具")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String metNum) {
        PersistModel data = busDeviceMeterServiceImpl.delete(metNum);
        return Result.builder(data);
    }

    @ApiOperation(value="查看表具集合", notes="查看表具集合")
    @GetMapping(value = "/queryBusDeviceMeterByPagination")
    public GridModel listByPagination(BusDeviceMeter busDeviceMeter) {
        busDeviceMeterServiceImpl.findAllByPagination(getPaginationUtility(), busDeviceMeter);
        return getGridModelResponse();
    }
}
