package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusDeviceParam;
import org.rcisoft.business.manage.service.BusDeviceParamService;
import org.rcisoft.business.manage.vo.BusDeviceParamList;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
* Created by  on 2018-5-2 16:09:29.
*/
@RestController
@RequestMapping("manage/busdeviceparam")
public class BusDeviceParamController extends PaginationController<BusDeviceParam> {

    @Autowired
    private BusDeviceParamService busDeviceParamServiceImpl;


    @ApiOperation(value="添加设备参数模板", notes="添加设备参数模板")
    @PostMapping(value = "/add")
    public Result add(@RequestBody BusDeviceParamList busDeviceParamList) {
        PersistModel data = busDeviceParamServiceImpl.save(busDeviceParamList);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
                busDeviceParamList);
    }


    @ApiOperation(value="修改设备参数模板", notes="修改设备参数模板")
    @PutMapping("/update")
    public Result update(@RequestBody BusDeviceParamList busDeviceParamList) {
        PersistModel data = busDeviceParamServiceImpl.merge(busDeviceParamList);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busDeviceParamList);
    }

    @ApiOperation(value="添加或修改设备参数模板", notes="添加或修改设备参数模板")
    @PutMapping("/saveOrupdate")
    public Result saveOrupdate(@RequestBody BusDeviceParamList busDeviceParamList) {
        PersistModel data = null;
        String devNum = busDeviceParamList.getBusDeviceParamList().get(0).getDevNum();
        List<Map<String,Object>> list = busDeviceParamServiceImpl.findByDev(devNum,busDeviceParamList.getProId());
        if(list.size()>0){
            data = busDeviceParamServiceImpl.merge(busDeviceParamList);
        }else{
            data = busDeviceParamServiceImpl.save(busDeviceParamList);
        }
        return Result.builder(data);
    }

    @ApiOperation(value="删除设备参数模板", notes="删除设备参数模板")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String devNum) {
        PersistModel data = busDeviceParamServiceImpl.delete(devNum);
        return Result.builder(data);
    }

    @ApiOperation(value="查看单个设备的参数模板", notes="查看单个设备的参数模板")
    @GetMapping("/detail")
    public List<Map<String,Object>> detail(@RequestParam String devNum,@RequestParam String proId) {
        return busDeviceParamServiceImpl.findByDev(devNum,proId);
    }

}
