package org.rcisoft.business.manage.controller;


/*固定导入*/
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusDeviceTp;
import org.rcisoft.business.manage.service.BusDeviceTpService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
* Created by  on 2018-5-2 16:09:29.
*/
@RestController
@RequestMapping("manage/busdevicetp")
public class BusDeviceTpController extends PaginationController<BusDeviceTp> {

    @Autowired
    private BusDeviceTpService busDeviceTpServiceImpl;


    @ApiOperation(value="添加设备类型", notes="添加设备类型")
    @PostMapping(value = "/add")
    public Result add(@Valid BusDeviceTp busDeviceTp) {
        PersistModel data = busDeviceTpServiceImpl.save(busDeviceTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        busDeviceTp);
    }


    @ApiOperation(value="修改设备类型", notes="修改设备类型")
    @PutMapping("/update")
    public Result update(@Valid BusDeviceTp busDeviceTp) {
        PersistModel data = busDeviceTpServiceImpl.merge(busDeviceTp);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        busDeviceTp);
    }

    @ApiOperation(value="删除设备类型", notes="删除设备类型")
    @PutMapping("/delete")
    public Result delete(@Valid BusDeviceTp busDeviceTp) {
        PersistModel data = busDeviceTpServiceImpl.delete(busDeviceTp);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busDeviceTp);
    }

    @ApiOperation(value="设备类型列表", notes="设备类型列表")
    @GetMapping(value = "/queryBusDeviceTpList")
    public String queryBusDeviceTpList(@RequestParam String proId) {
        return JSON.toJSONString(busDeviceTpServiceImpl.queryBusDeviceTpList(proId), SerializerFeature.WriteMapNullValue);
    }

    @RequestMapping("/upload")
    public Result upload(@RequestParam MultipartFile file,@RequestParam String devTpId) {
        PersistModel pm = busDeviceTpServiceImpl.upload(file,devTpId);
        return Result.builder(pm, MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, null);
    }
}
