package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusDevicetpParam;
import org.rcisoft.business.manage.service.BusDevicetpParamService;
import org.rcisoft.business.manage.vo.BusDevicetpParamList;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;

/**
* Created by  on 2018-5-2 16:09:29.
*/
@RestController
@RequestMapping("manage/busdevicetpparam")
public class BusDevicetpParamController extends PaginationController<BusDevicetpParam> {

    @Autowired
    private BusDevicetpParamService busDevicetpParamServiceImpl;

    /**
     * 批量出入设备类型模板
     * @param busDevicetpParamList
     * @return
     */
    @ApiOperation(value="添加设备类型模板", notes="添加设备类型模板")
    @PostMapping(value = "/add")
    public Result add(@RequestBody BusDevicetpParamList busDevicetpParamList) {
        PersistModel data = busDevicetpParamServiceImpl.save(busDevicetpParamList);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
                busDevicetpParamList);
    }

    /**
     * 先清空模板，后重新批量新增
     * @param busDevicetpParamList
     * @return
     */
    @ApiOperation(value="修改设备类型模板", notes="修改设备类型模板")
    @PostMapping(value = "/update")
    public Result update(@RequestBody BusDevicetpParamList busDevicetpParamList) {
        PersistModel data = busDevicetpParamServiceImpl.update(busDevicetpParamList);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busDevicetpParamList);
    }

    @ApiOperation(value="添加或修改设备类型模板", notes="添加或修改设备类型模板")
    @PostMapping(value = "/saveOrUpdate")
    public Result saveOrUpdate(@RequestBody BusDevicetpParamList busDevicetpParamList) {
        PersistModel data = null;
        List<BusDevicetpParam> list = busDevicetpParamServiceImpl.queryBusDevicetpParam(busDevicetpParamList.getBusDevicetpParamList().get(0));
        if(list.size()>0){
            data = busDevicetpParamServiceImpl.update(busDevicetpParamList);
        }else{
            data = busDevicetpParamServiceImpl.save(busDevicetpParamList);
        }
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busDevicetpParamList);
    }

    /**
     * 删除模板
     * @return
     */
    @ApiOperation(value="删除设备类型模板", notes="删除设备类型模板")
    @PostMapping(value = "/delete")
    public Result delete(@RequestParam String devTpId,@RequestParam String proId) {
        BusDevicetpParam bp = new BusDevicetpParam();
        bp.setDevTpId(devTpId);
        bp.setProId(proId);
        PersistModel data = busDevicetpParamServiceImpl.delete(bp);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                null);
    }

    /**
     * 查询设备类型模板
     * @return
     */
    @ApiOperation(value="查询设备类型模板", notes="查询设备类型模板")
    @PostMapping(value = "/query")
    public List<BusDevicetpParam> query(@RequestParam String devTpId, @RequestParam String proId) {
        BusDevicetpParam bp = new BusDevicetpParam();
        bp.setDevTpId(devTpId);
        bp.setProId(proId);
        return busDevicetpParamServiceImpl.queryBusDevicetpParam(bp);
    }
}
