package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusFactory;
import org.rcisoft.business.manage.service.BusFactoryService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.rcisoft.core.util.UserUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
* Created by  on 2018-5-16 14:34:55.
*/
@RestController
@RequestMapping("manage/busfactory")
public class BusFactoryController extends PaginationController<BusFactory> {

    @Autowired
    private BusFactoryService busFactoryServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/add")
    public Result add(@Valid BusFactory busFactory) {
        PersistModel data = busFactoryServiceImpl.save(busFactory);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        busFactory);
    }


    @ApiOperation(value="修改", notes="修改")
    @PutMapping("/update")
    public Result update(@Valid BusFactory busFactory) {
        PersistModel data = busFactoryServiceImpl.merge(busFactory);
        return Result.builder(data);
    }

    @ApiOperation(value="删除", notes="删除")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String id) {
        PersistModel data = busFactoryServiceImpl.delete(id);
        return Result.builder(data);
    }


    @ApiOperation(value="查看列表", notes="查看列表")
    @GetMapping(value = "/queryBusFactoryList")
    public List<Map<String,Object>> queryBusFactoryList() {
        return busFactoryServiceImpl.queryBusFactoryList();
    }
}
