package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusLibraryParam;
import org.rcisoft.business.manage.service.BusLibraryParamService;
import org.rcisoft.business.manage.vo.BusLibraryParamList;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;
import java.util.List;
import java.util.Map;

/**
* Created by  on 2018-5-2 16:09:30.
*/
@RestController
@RequestMapping("manage/buslibraryparam")
public class BusLibraryParamController extends PaginationController<BusLibraryParam> {

    @Autowired
    private BusLibraryParamService busLibraryParamServiceImpl;


    @ApiOperation(value="添加设备参数库模板", notes="添加设备参数库模板")
    @PostMapping(value = "/add")
    public Result add(@RequestBody BusLibraryParamList busLibraryParamList) {
        PersistModel data = busLibraryParamServiceImpl.save(busLibraryParamList);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
                busLibraryParamList);
    }


    @ApiOperation(value="修改设备参数库模板", notes="修改设备参数库模板")
    @PutMapping("/update")
    public Result update(@RequestBody BusLibraryParamList busLibraryParamList) {
        PersistModel data = busLibraryParamServiceImpl.merge(busLibraryParamList);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
                busLibraryParamList);
    }

    @ApiOperation(value="新增或修改设备参数库模板", notes="新增或修改设备参数库模板")
    @PutMapping("/saveOrupdate")
    public Result saveOrupdate(@RequestBody BusLibraryParamList busLibraryParamList) {
        PersistModel data = null;
        List<Map<String,Object>> libraryParam = busLibraryParamServiceImpl.queryLibraryParamByDev(busLibraryParamList.getBusLibraryParamList().get(0).getDevNum());
        if(libraryParam!=null && libraryParam.size()>0){
            data= busLibraryParamServiceImpl.merge(busLibraryParamList);
        }else{
            data = busLibraryParamServiceImpl.save(busLibraryParamList);
        }
        return Result.builder(data);
    }

    @ApiOperation(value="删除设备参数库模板", notes="删除设备参数库模板")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String devNum) {
        PersistModel data = busLibraryParamServiceImpl.delete(devNum);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                devNum);
    }

}
