package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.mainte.adaptive.entity.BusParamRefer;
import org.rcisoft.business.manage.entity.BusDeviceMeter;
import org.rcisoft.business.manage.service.BusParamReferService;
import org.rcisoft.business.manage.vo.BusParamReferVo;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
* Created by  on 2018-5-2 16:09:30.
*/
@RestController
@RequestMapping("manage/busparamrefer")
public class BusParamReferController extends PaginationController<BusParamRefer> {

    @Autowired
    private BusParamReferService busParamReferServiceImpl;


    @ApiOperation(value="修改", notes="修改")
    @PutMapping("/update")
    public Result update(@Valid BusParamRefer busParamRefer) {
        PersistModel data = busParamReferServiceImpl.merge(busParamRefer);
        return Result.builder(data);
    }

    @ApiOperation(value="新增", notes="新增")
    @PostMapping("/add")
    public Result add(@Valid BusParamReferVo busParamRefer) {
        PersistModel data = busParamReferServiceImpl.add(busParamRefer);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busParamRefer);
    }

    @ApiOperation(value="删除", notes="删除")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String id) {
        PersistModel data = busParamReferServiceImpl.delete(id);
        return Result.builder(data);
    }

    @ApiOperation(value="查看集合", notes="查看集合")
    @GetMapping(value = "/queryBusParamReferByPagination")
    public GridModel queryBusParamReferByPagination(@RequestParam String proId) {
        busParamReferServiceImpl.queryBusParamReferByPagination(getPaginationUtility(),proId);
        return getGridModelResponse();
    }

}
