package org.rcisoft.business.manage.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusFactory;
import org.rcisoft.business.manage.entity.BusProjectZone;
import org.rcisoft.business.manage.service.BusProjectZoneService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * Created by JiChao on 2018/5/7.
 */
@Api(tags = "建筑分区")
@RestController
@RequestMapping("busprojectzone")
public class BusProjectZoneController {

    @Autowired
    private BusProjectZoneService busProjectZoneServiceImpl;

    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/add")
    public Result add(@Valid BusProjectZone busProjectZone) {
        PersistModel data = busProjectZoneServiceImpl.save(busProjectZone);
        return Result.builder(data,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                busProjectZone);
    }


    @ApiOperation(value="修改", notes="修改")
    @PutMapping("/update")
    public Result update(@Valid BusProjectZone busProjectZone) {
        PersistModel data = busProjectZoneServiceImpl.merge(busProjectZone);
        return Result.builder(data);
    }

    @ApiOperation(value="删除", notes="删除")
    @DeleteMapping("/delete")
    public Result delete(@RequestParam String id) {
        PersistModel data = busProjectZoneServiceImpl.delete(id);
        return Result.builder(data);
    }

    @ApiOperation(value="查询建筑分区", notes="查询建筑分区")
    @RequestMapping("/getZone")
    public Result getZone() {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, busProjectZoneServiceImpl.getZone());
    }

}
