package org.rcisoft.business.manage.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.BusSaving;
import org.rcisoft.business.manage.service.BusSavingService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by JiChao on 2018/5/17.
 */
@Api(tags = "评估--节能改造--认定")
@RestController
@RequestMapping("bussaving")
public class BusSavingController {

    @Autowired
    private BusSavingService busSavingServiceImpl;

    @ApiOperation(value="修改", notes="传list对象")
    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "主键", required = true, dataType = "字符串"),
            @ApiImplicitParam(name = "examiner", value = "检定员", dataType = "字符串"),
            @ApiImplicitParam(name = "qualification", value = "执业资质", dataType = "字符串"),
            @ApiImplicitParam(name = "tm", value = "从业时间", dataType = "字符串"),
            @ApiImplicitParam(name = "performance", value = "项目业绩", dataType = "字符串"),
            @ApiImplicitParam(name = "type", value = "1：工程造价认定，2：节能认定", dataType = "字符串"),
            @ApiImplicitParam(name = "proId", value = "项目表主键", dataType = "字符串，可以不传")
    })
    @RequestMapping("/update")
    public Result update(@RequestBody List<BusSaving> busSavingList) {
        return Result.builder(busSavingServiceImpl.update(busSavingList));
    }

    @ApiOperation(value="查询", notes="2条记录，工程造价认定、节能认定")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "proId", value = "项目表主键", required = true, dataType = "字符串")
    })
    @RequestMapping("/queryBusSaving/{proId:\\w+}")
    public Result queryBusSaving(@PathVariable String proId) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, busSavingServiceImpl.queryBusSaving(proId));
    }

}
