package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.evaluate.team.entity.BusTeam;
import org.rcisoft.business.manage.service.BusTeamService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.WebRequest;

import javax.validation.Valid;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
* Created by  on 2018-5-16 14:34:55.
*/
@RestController
@RequestMapping("manage/busteam")
public class BusTeamController extends PaginationController<BusTeam> {

    @Autowired
    private BusTeamService busTeamServiceImpl;


    @ApiOperation(value="添加", notes="添加")
    @PostMapping(value = "/add")
    public Result add(@Valid BusTeam busTeam) {
        PersistModel data = busTeamServiceImpl.save(busTeam);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        busTeam);
    }


    @ApiOperation(value="修改", notes="修改")
    @PutMapping("/update")
    public Result update(@Valid BusTeam busTeam) {
        PersistModel data = busTeamServiceImpl.merge(busTeam);
        return Result.builder(data);
    }

    @ApiOperation(value="删除", notes="删除")
    @DeleteMapping("/delete")
    public Result update(@RequestParam String id) {
        PersistModel data = busTeamServiceImpl.delete(id);
        return Result.builder(data);
    }


    @ApiOperation(value="查看 集合", notes="查看 集合")
    @GetMapping(value = "/queryBusTeamByPagination")
    public GridModel listByPagination(@RequestParam String teamType) {
        busTeamServiceImpl.findAllByPagination(getPaginationUtility(), teamType);
        return getGridModelResponse();
    }

    @InitBinder
    public void initBinder(WebDataBinder webDataBinder, WebRequest webRequest) {
        DateFormat dateFormat=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        webDataBinder.registerCustomEditor(Date.class, new CustomDateEditor(dateFormat, true));
    }
}
