package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.service.EnergyPriceService;
import org.rcisoft.business.manage.vo.EnergyPriceList;
import org.rcisoft.business.overview.entity.EnergyPrice;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
* Created by  on 2018-5-16 14:34:55.
*/
@RestController
@RequestMapping("energyprice")
public class EnergyPriceController extends PaginationController<EnergyPrice> {

    @Autowired
    private EnergyPriceService energyPriceServiceImpl;



    @ApiOperation(value="修改", notes="修改")
    @PutMapping("/update")
    public Result update(@RequestBody EnergyPriceList energyPriceList) {
        PersistModel data = energyPriceServiceImpl.merge(energyPriceList);
        return Result.builder(data);
    }


    @ApiOperation(value="查看", notes="查看")
    @GetMapping(value = "/queryEnergyPrice")
    public Map<String,Object> queryEnergyPrice(@RequestParam String proId) {
        return energyPriceServiceImpl.queryEnergyPrice(proId);
    }
}
