package org.rcisoft.business.manage.controller;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.service.SysCityService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by JiChao on 2018/5/7.
 */
@Api(tags = "查询省份，城市")
@RestController
@RequestMapping("syscity")
public class SysCityController {

    @Autowired
    private SysCityService sysCityServiceImpl;

    @ApiOperation(value="查询省份", notes="查询省份")
    @RequestMapping("/province")
    public Result province() {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, sysCityServiceImpl.province());
    }

    @ApiOperation(value="查询城市", notes="查询城市")
    @ApiImplicitParams({@ApiImplicitParam(name = "pid", value = "城市主键", required = true, dataType = "字符串")})
    @RequestMapping("/city/{pid:\\w+}")
    public Result city(@PathVariable String pid) {
        return Result.builder(new PersistModel(1), MessageConstant.MESSAGE_ALERT_SUCCESS, MessageConstant.MESSAGE_ALERT_ERROR, sysCityServiceImpl.city(pid));
    }

}
