package org.rcisoft.business.manage.controller;


/*固定导入*/
import io.swagger.annotations.ApiOperation;
import org.rcisoft.business.manage.entity.SysUserProject;
import org.rcisoft.business.manage.service.SysUserProjectService;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.result.Result;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
* Created by  on 2018-5-10 13:29:46.
*/
@RestController
@RequestMapping("sysuserproject")
public class SysUserProjectController extends PaginationController<SysUserProject> {

    @Autowired
    private SysUserProjectService sysUserProjectServiceImpl;


    @ApiOperation(value="配置用户与项目关联关系", notes="配置用户与项目关联关系")
    @PostMapping(value = "/add")
    public Result add(@RequestParam String userId,@RequestParam String proIds) {
        String[] proArr = proIds.split(",");
        PersistModel data = sysUserProjectServiceImpl.save(userId,proArr);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        null);
    }

}
