package org.rcisoft.business.manage.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.manage.entity.BusDeviceMeter;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.security.access.method.P;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-5-2 16:09:29.
*/
@Repository
public interface BusDeviceMeterRepository extends BaseMapper<BusDeviceMeter> {

    /**
    * 分页查询 busDeviceMeter
    *
    */
    @Select("<script>select a.*,b.DEV_NM from bus_device_meter a,bus_device b  where a.DEV_NUM = b.DEV_NUM" +
            " and a.pro_id = #{proId} "
            + "</script>")
    List<Map<String,Object>> queryBusDeviceMeters(BusDeviceMeter busDeviceMeter);

    /**
     * 查询传感器是否有原始数据
     * @param map
     * @return
     */
    @Select("<script>select a.tm from total_original a,bus_device_meter b where a.dev_num = b.met_num and b.met_num = #{met_num} limit 1</script>")
    List<Map<String,Object>> queryOriginalByMet(Map<String,Object> map);


    /**
     * 根据表具编号查询表具信息
     * @param metNum
     * @return
     */
    @Select("<script>select * from bus_device_meter where met_num = #{metNum}</script>")
    List<Map<String,Object>> queryBusMetByMetNum(@Param("metNum") String metNum);
}

