package org.rcisoft.business.manage.dao;

import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.manage.entity.BusDeviceParam;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-5-2 16:09:29.
*/
@Repository
public interface BusDeviceParamRepository extends BaseMapper<BusDeviceParam> {

    /**
     * 根据设备编号查询参数模板
     * @param map
     * @return
     */
    @Select("<script>select a.*,b.PARAM_NM from bus_device_param a,bus_devicetp_param b where a.PARAM_CODE = b.PARAM_CODE" +
            " and b.PRO_ID = #{pro_id} and a.DEV_NUM = #{dev_num}" +
            "</script>")
    List<Map<String,Object>> detail(Map<String,Object> map);

    /**
     * 查询设备是否有参数库模板，存在的话无法删除设备模板
     * @param map
     * @return
     */
    @Select("<script>select * from bus_library_param where dev_num = #{dev_num}" +
            "</script>")
    List<Map<String,Object>> queryLibraryParamByDev(Map<String,Object> map);
}

