package org.rcisoft.business.manage.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.manage.entity.BusLibraryParam;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-5-2 16:09:30.
*/
@Repository
public interface BusLibraryParamRepository extends BaseMapper<BusLibraryParam> {

    @Select("<script>select * from bus_param_library where dev_num = #{dev_num} limit 1</script>")
    List<Map<String,Object>> queryParamLibraryByDev(Map<String,Object> map);

    /**
     * 查询参数编码
     * @param devNum 设备编号
     * @return param：参数代码，paramNm：参数名称
     */
    @Select("<script>select l.PARAM param,t.PARAM_NM paramNm from bus_library_param l,bus_device_param d,bus_devicetp_param t " +
            "where l.DEV_NUM=d.DEV_NUM and l.PARAM=d.PARAM and d.PARAM_CODE=t.PARAM_CODE " +
            "and l.DEV_NUM=#{devNum} and t.PRO_ID=substring_index(#{devNum}, '_', 1)</script>")
    List<Map<String, String>> selectParamsByDevNum(@Param(value = "devNum") String devNum);

    @Select("<script>select * from bus_library_param where dev_num = #{devNum}</script>")
    List<Map<String,Object>> queryLibraryParamByDev(@Param("devNum") String devNum);
}

