package org.rcisoft.business.manage.dao;

import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.manage.entity.BusProject;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
* Created with  on 2018-5-2 16:09:30.
*/
@Repository
public interface ProjectRepository extends BaseMapper<BusProject> {

    /**
     * 查看项目下是否有设备
     * @param map
     * @return
     */
    @Select("<script>select * from bus_device where pro_id = #{pro_id}" +
             "</script>")
    List<Map<String,Object>> queryDeivceByProject(Map<String,Object> map);

    /**
     * 查询用户权限项目
     * @param map
     * @return
     */
    @Select("<script>select a.* from bus_project a left join sys_user_project b on a.PRO_ID = b.PRO_ID\n" +
            "where b.USER_ID = #{user_id}" +
            "</script>")
    List<Map<String,Object>> queryBusProjectByUser(Map<String,Object> map);

    /**
     * 查询项目信息
     * @return
     */
    @Select("<script>SELECT\n" +
            "\ta.*,e.SYS_NM,b.BLD_TP_NM,c.OWN_NM,d1.TEAM_NM TEAM_NM_ON,d2.TEAM_NM TEAM_NM_OFF\n" +
            "FROM bus_project a \n" +
            "LEFT JOIN bus_build_tp b ON a.BLD_TP_ID = b.BLD_TP_ID\n" +
            "LEFT JOIN sys_owner c ON a.OWN_ID = c.OWN_ID\n" +
            "LEFT JOIN bus_team d1 on a.TEAM_ID_ON = d1.TEAM_ID\n" +
            "LEFT JOIN bus_team d2 on a.TEAM_ID_OFF = d2.TEAM_ID\n" +
            "LEFT JOIN bus_system e on a.PRO_ID = e.PRO_ID\n" +
            "where 1=1 " +
            "<if test =' proId != null '> and a.pro_id = #{proId}</if>" +
            "<if test =' jwnum != null '> and a.jwnum = #{jwnum}</if>" +
            "</script>")
    List<Map<String,Object>> queryBusProjects(BusProject busProject);
}

