package org.rcisoft.business.manage.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.manage.dao.BusDeviceMeterRepository;
import org.rcisoft.business.manage.entity.BusDeviceMeter;
import org.rcisoft.business.manage.service.BusDeviceMeterService;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * Created by  on 2018-5-2 16:09:29.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BusDeviceMeterServiceImpl implements BusDeviceMeterService {

    @Autowired
    private BusDeviceMeterRepository busDeviceMeterRepository;


    /**
    * 保存 busDeviceMeter
    * @param busDeviceMeter
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(BusDeviceMeter busDeviceMeter){
        int line = 1;
        String message = "";
        //增加操作
        busDeviceMeter.setMetId(UUID.randomUUID().toString().replace("-",""));
        if(busDeviceMeterRepository.queryBusMetByMetNum(busDeviceMeter.getMetNum())!=null && busDeviceMeterRepository.queryBusMetByMetNum(busDeviceMeter.getMetNum()).size()>0){
            line = 0;
            message = "表具编号已存在，新增失败";
        }else{
            line = busDeviceMeterRepository.insertSelective(busDeviceMeter);
        }
        return new PersistModel(line,message);
    }

    @Override
    public PersistModel delete(String metNum) {
        int line = 0;
        String message = "";
        Example example = new Example(BusDeviceMeter.class);
        Example.Criteria criteria = example.createCriteria();
        Map<String,Object> map = new HashMap<>();
        map.put("met_num",metNum);
        criteria.andEqualTo("metNum",metNum);
        if(busDeviceMeterRepository.queryOriginalByMet(map)==null || busDeviceMeterRepository.queryOriginalByMet(map).size()<1){
            line = busDeviceMeterRepository.deleteByExample(example);
        }else{
            message = "表具存在关联数据，删除失败";
        }
        return new PersistModel(line,message);
    }


    /**
    * 修改 busDeviceMeter
    * @param busDeviceMeter
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel merge(BusDeviceMeter busDeviceMeter){
        int line = 1;
        String message = "";
        Example example = new Example(BusDeviceMeter.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("metId",busDeviceMeter.getMetId());
        if(busDeviceMeter.getMetId()==null || busDeviceMeter.getMetId().equals("")){
            line = 0;
            message = "表具ID为空，更新失败";
        }else{
            line = busDeviceMeterRepository.updateByExampleSelective(busDeviceMeter,example);
        }
        return new PersistModel(line,message);
    }

    /**
    * 分页查询 busDeviceMeter
    * @param busDeviceMeter
    * @return
    */
    public List<Map<String,Object>> findAllByPagination(PageUtil<BusDeviceMeter> paginationUtility,
        BusDeviceMeter busDeviceMeter){
        if(busDeviceMeter.getProId()!=null && !busDeviceMeter.getProId().equals("")){
            return busDeviceMeterRepository.queryBusDeviceMeters(busDeviceMeter);
        }
        return null;

    }

}
