package org.rcisoft.business.manage.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.manage.dao.BusDevicetpParamRepository;
import org.rcisoft.business.manage.entity.BusDevicetpParam;
import org.rcisoft.business.manage.service.BusDevicetpParamService;
import org.rcisoft.business.manage.vo.BusDevicetpParamList;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-5-2 16:09:29.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BusDevicetpParamServiceImpl implements BusDevicetpParamService {

    @Autowired
    private BusDevicetpParamRepository busDevicetpParamRepository;


    /**
    * 批量插入设备类型模板
    * @return
    */
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel save(BusDevicetpParamList busDevicetpParamList){
        int line = 0;
        List<BusDevicetpParam> list = busDevicetpParamList.getBusDevicetpParamList();
        for(BusDevicetpParam bp : list){
            line = busDevicetpParamRepository.insertSelective(bp);
        }
        return new PersistModel(line);
    }
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel update(BusDevicetpParamList busDevicetpParamList) {
        PersistModel data = delete(busDevicetpParamList.getBusDevicetpParamList().get(0));
        if(data.isSuccessBySinglePersist()){
            save(busDevicetpParamList);
        }
        return new PersistModel(1);
    }
    @Transactional(propagation = Propagation.REQUIRED,isolation = Isolation.DEFAULT)
    @Override
    public PersistModel delete(BusDevicetpParam busDevicetpParam) {
        Example example = new Example(BusDevicetpParam.class);
        Example.Criteria criteria = example.createCriteria();
        Map<String,Object> map = new HashMap<>();
        map.put("devTpId",busDevicetpParam.getDevTpId());
        map.put("proId",busDevicetpParam.getProId());
        criteria.andEqualTo(map);
        int line = busDevicetpParamRepository.deleteByExample(example);
        return new PersistModel(line);
    }

    @Override
    public List<BusDevicetpParam> queryBusDevicetpParam(BusDevicetpParam bp) {
        Example example = new Example(BusDevicetpParam.class);
        Example.Criteria criteria = example.createCriteria();
        Map<String,Object> map = new HashMap<>();
        map.put("devTpId",bp.getDevTpId());
        map.put("proId",bp.getProId());
        criteria.andEqualTo(map);
        return busDevicetpParamRepository.selectByExample(example);
    }

}
