package org.rcisoft.business.manage.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.mainte.adaptive.dao.BusParamReferRepository;
import org.rcisoft.business.mainte.adaptive.entity.BusParamRefer;
import org.rcisoft.business.manage.entity.BusDeviceMeter;
import org.rcisoft.business.manage.service.BusParamReferService;
import org.rcisoft.business.manage.vo.BusParamReferVo;
import org.rcisoft.core.aop.PageUtil;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * Created by  on 2018-5-2 16:09:30.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class BusParamReferServiceImpl implements BusParamReferService {

    @Autowired
    private BusParamReferRepository busParamReferRepository;


    @Override
    public PersistModel merge(BusParamRefer busParamRefer) {
        int line = 1;
        String message = "";
        Example example = new Example(BusParamRefer.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("id",busParamRefer.getId());
        if(busParamRefer.getId()!=null && !busParamRefer.getId().equals("")){
            line = busParamReferRepository.updateByExampleSelective(busParamRefer,example);
        }else{
            line = 0;
            message = "ID为空，更新失败";
        }
        return new PersistModel(line,message);
    }

    @Override
    public PersistModel delete(String id) {
        int line = 1;
        String message = "";
        Example example = new Example(BusParamRefer.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("id",id);
        if(id!=null && !id.equals("")){
            line = busParamReferRepository.deleteByExample(example);
        }else{
            line = 0;
            message = "ID为空，删除失败";
        }
        return new PersistModel(line,message);
    }

    @Override
    public PersistModel add(BusParamReferVo busParamRefer) {
        BusParamRefer bpr = new BusParamRefer();
        bpr.setId(UUID.randomUUID().toString().replace("-",""));
        bpr.setOwnParam(busParamRefer.getOwnParam());
        bpr.setDevNum(busParamRefer.getNum());
        bpr.setDevType(busParamRefer.getDevType());
        bpr.setProId(busParamRefer.getProId());
        bpr.setOtherParam(busParamRefer.getOtherParam());
        bpr.setOwnParamNm(busParamRefer.getParamNm());
        int line = busParamReferRepository.insertSelective(bpr);
        return new PersistModel(line);
    }

    @Override
    public List<Map<String, Object>> queryBusParamReferByPagination(PageUtil paginationUtility, String proId) {
        return busParamReferRepository.queryBusParamReferByPagination(proId);
    }
}
