package org.rcisoft.business.manage.service.impl;

import org.rcisoft.business.manage.dao.BusProjectZoneRepository;
import org.rcisoft.business.manage.entity.BusFactory;
import org.rcisoft.business.manage.entity.BusProjectZone;
import org.rcisoft.business.manage.service.BusProjectZoneService;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import tk.mybatis.mapper.entity.Example;

import java.util.List;
import java.util.UUID;

/**
 * Created by JiChao on 2018/5/7.
 */
@Service
public class BusProjectZoneServiceImpl implements BusProjectZoneService {

    @Autowired
    private BusProjectZoneRepository busProjectZoneRepository;

    @Override
    public PersistModel save(BusProjectZone busProjectZone) {
        //增加操作
        busProjectZone.setBldZoneId(UUID.randomUUID().toString().replace("-",""));
        int line = busProjectZoneRepository.insertSelective(busProjectZone);
        return new PersistModel(line);
    }

    @Override
    public PersistModel merge(BusProjectZone busProjectZone) {
        Integer line = 0;
        String message = "";
        Example example = new Example(BusFactory.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("bldZoneId",busProjectZone.getBldZoneId());
        if(busProjectZone.getBldZoneId()!=null && !busProjectZone.getBldZoneId().equals("")){
            line = busProjectZoneRepository.updateByExampleSelective(busProjectZone,example);
        }else{
            message = "ID为空，更新失败";
        }
        return new PersistModel(line,message);
    }

    @Override
    public PersistModel delete(String id) {
        Integer line = 0;
        String message = "";
        Example example = new Example(BusProjectZone.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("bldZoneId",id);
        if(id!=null && !id.equals("")){
            line = busProjectZoneRepository.deleteByExample(example);
        }else{
            message = "ID为空，删除失败";
        }
        return new PersistModel(line,message);
    }

    @Override
    public List<BusProjectZone> getZone() {
        return busProjectZoneRepository.selectAll();
    }
}
