package org.rcisoft.business.manage.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.manage.dao.BusSavingRepository;
import org.rcisoft.business.manage.entity.BusSaving;
import org.rcisoft.business.manage.service.BusSavingService;
import org.rcisoft.business.overview.entity.BusProjectArea;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.List;

/**
 * Created by JiChao on 2018/5/17.
 */
@Service
public class BusSavingServiceImpl implements BusSavingService {

    @Autowired
    private BusSavingRepository busSavingRepository;

    @Transactional
    @Override
    public PersistModel save(List<BusSaving> busSavingList) {
        int result = 0;
        for (BusSaving busSaving : busSavingList) {
            result += busSavingRepository.insert(busSaving);
        }
        return new PersistModel(result);
    }

    @Transactional
    @Override
    public PersistModel update(List<BusSaving> busSavingList) {
        int result = 0;
        String message = "";
        Example example = new Example(BusSaving.class);
        Example.Criteria criteria = example.createCriteria();
        for (BusSaving busSaving : busSavingList) {
            String id = busSaving.getId();
            criteria.andEqualTo("id", id);
            if (StringUtils.isNotEmpty(id)) {
                result += busSavingRepository.updateByExample(busSaving, criteria);
                message = "更新成功";
            } else {
                message = "ID为空，更新失败";
            }
        }
        return new PersistModel(result, message);
    }

    @Transactional
    @Override
    public PersistModel delete(String proId) {
        int result = 0;
        String message = "";
        Example example = new Example(BusSaving.class);
        Example.Criteria criteria = example.createCriteria();
        if (StringUtils.isNotEmpty(proId)) {
            criteria.andEqualTo("proId", proId);
            result += busSavingRepository.deleteByExample(criteria);
            message = "删除成功";
        } else {
            message = "项目ID为空，删除失败";
        }
        return new PersistModel(result, message);
    }

    @Override
    public List<BusSaving> queryBusSaving(String proId) {
        Example example = new Example(BusSaving.class);
        Example.Criteria criteria = example.createCriteria();
        criteria.andEqualTo("proId", proId);
        return busSavingRepository.selectByExample(criteria);
    }
}
