package org.rcisoft.business.manage.service.impl;

import org.apache.commons.lang3.StringUtils;
import org.rcisoft.business.manage.dao.SysCityRepository;
import org.rcisoft.business.manage.dao.SysProvinceRepository;
import org.rcisoft.business.manage.entity.SysCity;
import org.rcisoft.business.manage.entity.SysProvince;
import org.rcisoft.business.manage.service.SysCityService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by JiChao on 2018/5/7.
 */
@Service
public class SysCityServiceImpl implements SysCityService {

    @Autowired
    private SysProvinceRepository sysProvinceRepository;
    @Autowired
    private SysCityRepository sysCityRepository;

    @Override
    public List<SysProvince> province() {
        // 返回的结果，省份list
        List<SysProvince> provinceList = sysProvinceRepository.selectAll();
        List<SysCity> cityList = sysCityRepository.selectAll();
        // 将city的值放入
        provinceList.forEach(sysProvince -> {
            String provinceId = sysProvince.getId();
            List<SysCity> province_cityList = sysProvince.getCity();
            for (int i = 0; i < cityList.size(); i++) {
                SysCity sysCity = cityList.get(i);
                String provincePid = sysCity.getPid();
                if (StringUtils.equals(provinceId, provincePid)) {
                    province_cityList.add(sysCity);
                    cityList.remove(i--);
                }
            }
        });
        return provinceList;
    }

    @Override
    public List<SysCity> city(String pid) {
        SysCity s = new SysCity();
        s.setPid(pid);
        return sysCityRepository.select(s);
    }
}
