package org.rcisoft.business.manage.service.impl;

import lombok.extern.slf4j.Slf4j;
import org.rcisoft.business.manage.dao.SysUserProjectRepository;
import org.rcisoft.business.manage.entity.SysUserProject;
import org.rcisoft.business.manage.service.SysUserProjectService;
import org.rcisoft.core.model.PersistModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import tk.mybatis.mapper.entity.Example;

import java.util.List;
import java.util.Map;

/**
 * Created by  on 2018-5-10 13:29:46.
 */
@Service
@Transactional(readOnly = true,propagation = Propagation.NOT_SUPPORTED)
@Slf4j
public class SysUserProjectServiceImpl implements SysUserProjectService {

    @Autowired
    private SysUserProjectRepository sysUserProjectRepository;

    /**
     * 配置用户与项目关联关系
     * @return
     */
    @Transactional
    @Override
    public PersistModel save(String userId,String[] proIds) {
        int line = 1;
        try{
            //先删除关系后重新配置
            Example example = new Example(SysUserProject.class);
            Example.Criteria criteria = example.createCriteria();
            criteria.andEqualTo("userId",userId);
            sysUserProjectRepository.deleteByExample(example);

            if(proIds.length>0){
                for(String proId : proIds){
                    SysUserProject sup = new SysUserProject();
                    sup.setUserId(userId);
                    sup.setProId(proId);
                    sysUserProjectRepository.insertSelective(sup);
                }
            }
        }catch(Exception e){
            e.printStackTrace();
            line = 0;
        }
        return new PersistModel(line);
    }
}
