package org.rcisoft.business.overview.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.ResultMap;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.manage.vo.EnergyPriceVo;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * Created by JiChao on 2018/4/11.
 * 概览
 */
@Repository
public interface EnergyPriceRepository extends BaseMapper<EnergyPriceVo> {

    /**
     * 根据项目id搜索水电气价格列表
     * @param  proId：项目id，pHour：小时
     * @return
     */
    @Select("<script>select e.P_HOUR,SUM(IF(e.P_TP=1, e.P_PRICE, 0)) as WATER,SUM(IF(e.P_TP=2, e.P_PRICE, 0)) as ELEC,SUM(IF(e.P_TP=3, e.P_PRICE, 0)) as GAS from energy_price e where e.PRO_ID=#{proId} and e.P_HOUR=#{pHour}</script>")
    @ResultMap("vo")
    EnergyPriceVo getPrice(@Param("proId") String proId,@Param("pHour") String pHour);

    /**
     * 查询项目能耗价格
     * @param proId
     * @return
     */
    @Select("<script>select * from energy_price where pro_id = #{proId}</script>")
    List<Map<String,Object>> queryEnergyPrice(@Param("proId") String proId);

}
