package org.rcisoft.business.system.user.dao;

import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.rcisoft.business.system.user.entity.SysAdmins;
import org.rcisoft.business.system.user.entity.SysOwner;
import org.rcisoft.core.base.BaseMapper;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

/**
 * @Author: GaoLiWei
 * @Date: Created in 10:422018/5/2
 */
@Repository
public interface OwnerRepository extends BaseMapper<SysOwner>{


    /** 根据userId查询业主信息
     * @param userId
     * @return
     */
    SysOwner getSysOwnerByUserId(@Param("userId") String userId);

    /** 根据userId删除业主信息
     * @param userId
     * @return
     */
    Integer deleteSysOwnerByUserId(@Param("userId") String userId);

    /**
     * 所有业主列表
     * @return
     */
    @Select("<script>select * from sys_owner</script>")
    List<Map<String,Object>> listOwnerAll();

}
