package org.rcisoft.business.totaloriginal.controller;


/*固定导入*/
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.core.service.RcRedisService;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.Result;
import org.rcisoft.core.model.PersistModel;
import org.rcisoft.core.constant.MessageConstant;
import org.rcisoft.core.controller.PaginationController;
import org.rcisoft.core.model.GridModel;
import javax.validation.Valid;


import org.rcisoft.business.totaloriginal.entity.TotalOriginal;
import org.rcisoft.business.totaloriginal.service.TotalOriginalService;


/**
* Created by  on 2018-4-12 15:48:19.
*/
@RestController
@RequestMapping("totaloriginal")
public class TotalOriginalController extends PaginationController<TotalOriginal> {

    @Autowired
    private TotalOriginalService totalOriginalServiceImpl;
    @Autowired
    private RcRedisService rcRedisService;

    @ApiOperation(value="查看缓存 ", notes="查看缓存 ")
    @GetMapping("/getredis")
    public Result getRedis() {
        return Result.builder(new PersistModel(1) ,
                MessageConstant.MESSAGE_ALERT_SUCCESS,
                MessageConstant.MESSAGE_ALERT_ERROR,
                rcRedisService.get("old"));
    }

    @ApiOperation(value="添加", notes="添加")
    //@ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PostMapping(value = "/add")
    public Result add(@Valid TotalOriginal totalOriginal, BindingResult bindingResult) {
        PersistModel data = totalOriginalServiceImpl.save(totalOriginal);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        totalOriginal);
    }

    @ApiOperation(value="逻辑删除", notes="逻辑删除")
    @ApiImplicitParams({@ApiImplicitParam(name = "id", value = "id", required = false, dataType = "varchar")})
    @DeleteMapping("/delete/{id:\\w+}")
    public Result delete(@PathVariable String id) {
        TotalOriginal totalOriginal = new TotalOriginal();
        PersistModel data = totalOriginalServiceImpl.remove(totalOriginal);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        id);
    }

    @ApiOperation(value="修改", notes="修改")
    @ApiImplicitParams({@ApiImplicitParam(name = "businessId", value = "businessId", required = false, dataType = "varchar")})
    @PutMapping("/update/{id:\\w+}")
    public Result update(@Valid TotalOriginal totalOriginal, BindingResult bindingResult) {
        PersistModel data = totalOriginalServiceImpl.merge(totalOriginal);
        return Result.builder(data,
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        totalOriginal);
    }

    @ApiOperation(value="查看单 ", notes="查看单 ")
    @GetMapping("/detail/{id:\\w+}")
    public Result detail(@PathVariable int id) {
        return Result.builder(new PersistModel(1),
            MessageConstant.MESSAGE_ALERT_SUCCESS,
            MessageConstant.MESSAGE_ALERT_ERROR,
        totalOriginalServiceImpl.findById(id));
    }

    @ApiOperation(value="查看  集合", notes="查看  集合")
    @GetMapping(value = "/queryTotalOriginalByPagination")
    public GridModel listByPagination(TotalOriginal totalOriginal) {
        totalOriginalServiceImpl.findAllByPagination(getPaginationUtility(), totalOriginal);
        return getGridModelResponse();
    }
}
