package org.rcisoft.common.component;

import com.google.common.collect.Maps;
import lombok.Data;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.io.Serializable;
import java.util.Map;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 下午3:50
 * description: global config
 */
@Component
@Data
public class Global implements Serializable{


    private static final long serialVersionUID = -7950787304594954554L;
    /**
     * 保存全局属性值
     */
    static Map<String, String> map = Maps.newHashMap();


    /**
     * jwt
     */
    @Value("${jwt.header}")
    private String JWT_HEADER;

    @Value("${jwt.tokenHead}")
    private String JWT_TOKEN_HEAD;

    /*管理员Code*/
    @Value("${global.code.admin}")
    private String adminCode;

    /**
     * 基本存储路径
     */
    @Value("${global.path.base_upload_location}")
    private String baseUploadLocation;

    /*
     * 代码
     */
    @Value("${global.path.code_generate_location}")
    private String codeGenerateLocation;

    /*视频路径*/
    @Value("${global.path.video_location}")
    private String VIDEO_LOCATION;

    /*临时路径*/
    @Value("${global.path.temp_location}")
    private String TEMP_LOCATION;

    /*附件路径*/
    @Value("${global.path.file_location}")
    private String FILE_LOCATION;

    /*图片路径*/
    @Value("${global.path.images_location}")
    private String IMAGES_LOCATION;


}
