package org.rcisoft.core.entity;


import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.rcisoft.core.util.IdGen;

import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Transient;
import java.io.Serializable;

/**
 * Created with family.
 * author: cy
 * Date: 16/6/2
 * Time: 上午9:15
 * description: id entity
 */
@NoArgsConstructor
@AllArgsConstructor
@MappedSuperclass
@Data
public abstract class IdNotDataEntity<T>  implements Serializable {

    private static final long serialVersionUID = 2L;

    @Id
    protected String businessId;		// 编号


    @Transient
    protected String token;

    /**
     * 通用设置ID
     */
    public void setCommonBusinessId(){
        this.setBusinessId(IdGen.uuid());
    }

    public String getBusinessId() {
        return businessId;
    }

    public void setBusinessId(String businessId) {
        this.businessId = businessId;
    }

    public String getToken() {
        return token;
    }

    public void setToken(String token) {
        this.token = token;
    }
}